function k = makefilter2d(type,fsize,osize,cpi,fbw,ori,obw)
% 
% gEʃtB^
%
%  fsize  : gtB^̃TCY
%  osize  : ʃtB^̃TCY
%
%  type = 'Bandpass'̂Ƃ
%  cpi    : ʉߒSg(cycle/image)
%  fbw    : ʉߑш̔lS(octave:0ȉƂ͎Ƃ)
%  ori    : ʉߒS(deg)
%  obw    : ʉߑш̔lS(deg:0ȉƂ͎Ƃ)
%
%  type = 'Lowpass'̂Ƃ
%  cpi    : ʉߏg(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%  ori    : 
%  obw    : 
%
%  type = 'Highpass'̂Ƃ
%  cpi    : ʉ߉g(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%  ori    : 
%  obw    : 
%
%  type = 'Fractal'̂Ƃ
%  cpi    : 
%  fbw    : gʉߓ̃X[v
%  ori    : 
%  obw    : 
% 
% k = makefilter2d(type,fsize,osize,cpi,fbw,ori,obw)
%
%--------------------------------------------------------------------------
% 
% gp: ohpXmCY摜̍쐬
% 
% fsize        = 256;
% osize        = 256;
% type         = 'Bandpass';
% cpi          = 30;
% fbw          = 5;
% ori          = 30;
% obw          = 135;
% 
% k = makefilter2d(type,fsize,osize,cpi,fbw,ori,obw);  % ohpXtB^쐬
% ri = rand(256);                                      % _mCY摜쐬
% ci = cnt(ri,mean2(ri));                              % RgXglɕϊ
% fi = filter2d(ci,k,'Freq');                          % tB^O
% imshow(lum(real(fi),mean2(ri)))                      % Pxlɒĕ`
% 
%--------------------------------------------------------------------------
[f,o] = makegrid('Polar',fsize,osize);
if strcmp(type,'Bandpass')
    if fbw>0
        kf = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    else
        kf = 1; 
    end
    if obw>0
        ko = exp(-((o-ori)).^2  / (2.*(fwmh2sd(obw).^2)))  + exp(-((o-ori-180)).^2  / (2.*(fwmh2sd(obw).^2)))...
            + exp(-((o-ori-360)).^2  / (2.*(fwmh2sd(obw).^2))) + exp(-((o-ori-180-360)).^2  / (2.*(fwmh2sd(obw).^2)))...
            + exp(-((o-ori-360-360)).^2  / (2.*(fwmh2sd(obw).^2))) + exp(-((o-ori-180-360-360)).^2  / (2.*(fwmh2sd(obw).^2)));
    else
        ko = 1;
    end
    k = kf.*ko;
elseif strcmp(type,'Lowpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f<=cpi) = 1;
elseif strcmp(type,'Highpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f>=cpi) = 1;
elseif strcmp(type,'Fractal')
    k = 1./(f.^fbw);
end

end