function k = makefilter3d(type,fsize,osize,tsize,cpi,fbw,ori,obw,tlambda,tbw)
% 
% gEʁEԃtB^
%
%  fsize  : gtB^̃TCY
%  osize  : ʃtB^̃TCY
%  tsize  : ԃtB^̃TCY
%
%  type = 'Bandpass'̂Ƃ
%  cpi    : ʉߒSg(cycle/image)
%  fbw    : ʉߑш̔lS(octave:0ȉƂ͎Ƃ)
%  ori    : ʉߒS(deg)
%  obw    : ʉߑш̔lS(deg:0ȉƂ͎Ƃ)
%  tlambda: ʉߒS(frame)
%  tbw    : ʉߑш̔lS(octave:0ȉƂ͎Ƃ)
%
%  type = 'Lowpass'̂Ƃ
%  cpi    : ʉߏg(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%  ori    : 
%  obw    : 
%  tlambda: 
%  tbw    : 
%
%  type = 'Highpass'̂Ƃ
%  cpi    : ʉ߉g(cycle/image)
%  fbw    : JbgItш̔lS(octave)
%  ori    : 
%  obw    : 
%  tlmabda: 
%  tbw    : 
%
%  type = 'Fractal'̂Ƃ
%  cpi    : 
%  fbw    : gʉߓ̃X[v
%  ori    : 
%  obw    : 
%  tlmabda: 
%  tbw    : 
%
% k = makefilter3d(type,fsize,osize,tsize,cpi,fbw,ori,obw,tlambda,tbw)
% 
%--------------------------------------------------------------------------
% gp: ohpXmCY摜̍쐬
%--------------------------------------------------------------------------
[f,o] = makegrid('Polar',fsize,osize);
t = abs(-(tsize-1)*0.5:(tsize-1)*0.5);
if strcmp(type,'Bandpass')
    if fbw>0
        kf = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    else
        kf = 1; 
    end
    if tbw>0
        kt = exp(-(log2(t)-log2(tlambda)).^2  / (2.*(fwmh2sd(tbw).^2)));
    else
        kt = 1; 
    end    
    if obw>0
        ko = exp(-((o-ori)).^2  / (2.*(fwmh2sd(obw).^2)))  + exp(-((o-ori-180)).^2  / (2.*(fwmh2sd(obw).^2)))...
            + exp(-((o-ori-360)).^2  / (2.*(fwmh2sd(obw).^2))) + exp(-((o-ori-180-360)).^2  / (2.*(fwmh2sd(obw).^2)))...
            + exp(-((o-ori-360-360)).^2  / (2.*(fwmh2sd(obw).^2))) + exp(-((o-ori-180-360-360)).^2  / (2.*(fwmh2sd(obw).^2)));
    else
        ko = 1;
    end
    k = zeros(size(kf,1),size(kf,2),numel(kt));
    for i = 1:numel(kt)
        k(:,:,i) = kf.*ko.*kt(i);
    end

elseif strcmp(type,'Lowpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f<=cpi) = 1;
elseif strcmp(type,'Highpass')
    k = exp(-(log2(f)-log2(cpi)).^2  / (2.*(fwmh2sd(fbw).^2)));
    k(f>=cpi) = 1;
elseif strcmp(type,'Fractal')
    k = 1./(f.^fbw);
end

end