function [x,y] = makegrid(type,xn,yn)
%
% Obh
%  type   : Obh̃^Cv(`fJg='Linear' ɍW='Polar' xg(octave)='Fourier')
% 
% [x,y] = makeGrid(type,nx,ny)
%
%--------------------------------------------------------------------------
% 
% gp: giqp^[̍쐬A\D
%
% lambda = 64;
% ori    = 30;
% ph     = 0;
% cnt    = 1;
% type   = 'Sawtooth';
% 
% [x,y] = makegrid('Linear',256,256);           % bVObh쐬
% im = grating2d(x,y,type,lambda,ori,ph,cnt);   % g̊iqs쐬
% imshow(lum(im,0.5));                        	% RgXgPxlɕϊĕ`
% 
%--------------------------------------------------------------------------
if isempty(type)
    [x,y] = meshgrid(0.5:xn-0.5,0.5:yn-0.5);
elseif strcmp(type,'Linear')
    [x,y] = meshgrid(-(xn-1)/2:(xn-1)/2,-(yn-1)/2:(yn-1)/2);  
elseif strcmp(type,'Polar')
    [a,b] = meshgrid(-(xn-1)/2:(xn-1)/2,-(yn-1)/2:(yn-1)/2);
    x = sqrt(a.^2+b.^2);
    y = rad2deg(mod(atan2(-b,a),2*pi));
elseif strcmp(type,'Fourier')
    [a,b] = meshgrid(-(xn-1)/2:(xn-1)/2,-(yn-1)/2:(yn-1)/2);
    x = mod(rad2deg(mod(atan2(-b,a),2*pi)),180);
    y = log2(fftshift(sqrt(a.^2+b.^2)));
end

end