function PM = updatePSI(PM,cond,Ncond,response,varargin)
%
% PSI@ɂ̎hx𓾂(nXV)D
%
%  PM       : initPSIŏ\̖
%  cond     : ԍ
%  Ncond    : nԍ
%  response : 񓚂̐(=1 =0)
%
% PM = updatePSI(PM,cond,Ncond,response)
%
% Palamedes toolbox(Prins & Kingdom, 2009)gp
%
% ftHgvaragin:
%
% PM = updatePSI(PM,cond,Ncond,response,'fixLapse',0);
%
%--------------------------------------------------------------------------
% 
% gp: PSI@ɂhl肷D
% 
% condm = 5;                        % 
% Ncondm = 3;                       % e̊Kin
% stim = 0.1;                       % l
%
% PM = initPSI(condm,Ncondm);
% 
% ** ȉ͎h񎦂Ɣ̃[vłȂ **
% 
% cond = 2;                         % ԍ(sƂɐݒ)
% Ncond = 2;                        % nԍ(sƂɐݒ)
% 
% test = PSI(PM,cond,Ncond);
% stim = stim*(2^test);             % Os̎hl(l)ɑ΂IN^[uKi@ɂω
% 
% response = 1;                     % 擾(0/1)
%
% PM = updatePSI(PM,cond,Ncond,response);
% 
%--------------------------------------------------------------------------
% Modified Palamedes toolbox 2016.10.28 by RN
%
%PAL_AMPM_updatePM  Updates structure which contains settings for and 
%   results of psi method adaptive method (see also PAL_AMPM_setupPM).
%   
%   syntax: PM = PAL_AMPM_updatePM(PM,response,{optional argument})
%
%After having created a structure 'PM' using PAL_AMPM_setupPM, use 
%   something akin to the following loop to control stimulus intensity
%   during experimental run:
%
%   while ~PM.stop
%       
%       %Present trial here at stimulus magnitude in 'PM.xCurrent'
%       %and collect response (1: correct/greater than, 0: incorrect/
%       %smaller than)
%
%       PM = PAL_AMPM_updatePM(PM, response); %update PM structure based 
%                                             %on response                                    
%    
%    end
%
%If multiple lapse rates are included in the prior distribution (i.e., if
%   PM.priorLambdaRange is a vector [see PAL_AMPM_setupPM]), the psi method
%   has a tendency to produce series of consecutive placements at very high
%   stimulus intensities. In order to avoid this, one has the option to use
%   a fixed lapse rate on any trial (i.e., as the original Psi Method would
%   [Kontsevich & Tyler, 1999]). The value that will be used for the fixed
%   lapse rate is the value corresponding to its current maximum likelihood
%   estimate. Generally (though not necessarily, especially at the start of 
%   a run), the resulting selection for stimulus intensity will not be near 
%   asymptotic performance. In order to select a stimulus intensity using a 
%   fixed lapse rate use the optional argument 'fixLapse', followed by a 
%   logical TRUE. Example:
%
%   PM = PAL_AMPM_updatePM(PM, response, 'fixLapse',1);
%
%   For more information see: www.palamedestoolbox.org/psimarginal.html
%
%Introduced: Palamedes version 1.0.0 (NP)
%Modified: Palamedes version 1.5.0, 1.6.0, 1.6.1, 1.6.3 (see History.m)

fixLapse = false;

valid = 0;
if ~isempty(varargin)
    if strncmpi(varargin{1}, 'fixL',4)            
        fixLapse = varargin{2};                
        valid = 1;
    end
    if valid == 0
        warning('PALAMEDES:invalidOption','%s is not a valid option. Ignored.',varargin{1})
    end        
end

trial = length(PM(Ncond*(cond-1)+Ncond).x);
PM(Ncond*(cond-1)+Ncond).response(trial) = response;

if response == 1
    PM(Ncond*(cond-1)+Ncond).pdf = PM(Ncond*(cond-1)+Ncond).posteriorTplus1givenSuccess(:,:,:,:,find(PM(Ncond*(cond-1)+Ncond).stimRange == PM(Ncond*(cond-1)+Ncond).xCurrent));
else
    PM(Ncond*(cond-1)+Ncond).pdf = PM(Ncond*(cond-1)+Ncond).posteriorTplus1givenFailure(:,:,:,:,find(PM(Ncond*(cond-1)+Ncond).stimRange == PM(Ncond*(cond-1)+Ncond).xCurrent));
end
PM(Ncond*(cond-1)+Ncond).pdf = PM(Ncond*(cond-1)+Ncond).pdf./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf))));

[PM(Ncond*(cond-1)+Ncond), expectedEntropy] = PAL_AMPM_expectedEntropy(PM(Ncond*(cond-1)+Ncond),'fixLapse',fixLapse);

[minEntropy, PM(Ncond*(cond-1)+Ncond).I] = min(squeeze(expectedEntropy));

PM(Ncond*(cond-1)+Ncond).xCurrent = PM(Ncond*(cond-1)+Ncond).stimRange(PM(Ncond*(cond-1)+Ncond).I);
PM(Ncond*(cond-1)+Ncond).x(trial+1) = PM(Ncond*(cond-1)+Ncond).xCurrent;

PM(Ncond*(cond-1)+Ncond).threshold(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorAlphas.*PM(Ncond*(cond-1)+Ncond).pdf))));
PM(Ncond*(cond-1)+Ncond).slope(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorBetas.*PM(Ncond*(cond-1)+Ncond).pdf))));
PM(Ncond*(cond-1)+Ncond).guess(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorGammas.*PM(Ncond*(cond-1)+Ncond).pdf))));
PM(Ncond*(cond-1)+Ncond).lapse(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorLambdas.*PM(Ncond*(cond-1)+Ncond).pdf))));
PM(Ncond*(cond-1)+Ncond).seThreshold(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorAlphas-PM(Ncond*(cond-1)+Ncond).threshold(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf)))));
PM(Ncond*(cond-1)+Ncond).seSlope(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorBetas-PM(Ncond*(cond-1)+Ncond).slope(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf)))));
PM(Ncond*(cond-1)+Ncond).seGuess(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorGammas-PM(Ncond*(cond-1)+Ncond).guess(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf)))));
PM(Ncond*(cond-1)+Ncond).seLapse(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorLambdas-PM(Ncond*(cond-1)+Ncond).lapse(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf)))));

PM(Ncond*(cond-1)+Ncond).thresholdUniformPrior(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorAlphas.*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))));
PM(Ncond*(cond-1)+Ncond).slopeUniformPrior(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorBetas.*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))));
PM(Ncond*(cond-1)+Ncond).guessUniformPrior(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorGammas.*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))));
PM(Ncond*(cond-1)+Ncond).lapseUniformPrior(trial) = sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).priorLambdas.*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))));
PM(Ncond*(cond-1)+Ncond).seThresholdUniformPrior(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorAlphas-PM(Ncond*(cond-1)+Ncond).thresholdUniformPrior(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior)))));
PM(Ncond*(cond-1)+Ncond).seSlopeUniformPrior(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorBetas-PM(Ncond*(cond-1)+Ncond).slopeUniformPrior(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior)))));
PM(Ncond*(cond-1)+Ncond).seGuessUniformPrior(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorGammas-PM(Ncond*(cond-1)+Ncond).guessUniformPrior(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior)))));
PM(Ncond*(cond-1)+Ncond).seLapseUniformPrior(trial) = sqrt(sum(sum(sum(sum(((PM(Ncond*(cond-1)+Ncond).priorLambdas-PM(Ncond*(cond-1)+Ncond).lapseUniformPrior(trial)).^2).*PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior))))./sum(sum(sum(sum(PM(Ncond*(cond-1)+Ncond).pdf./PM(Ncond*(cond-1)+Ncond).prior)))));

if PM(Ncond*(cond-1)+Ncond).gammaEQlambda
    PM(Ncond*(cond-1)+Ncond).guess(trial) = PM(Ncond*(cond-1)+Ncond).lapse(trial);
    PM(Ncond*(cond-1)+Ncond).seGuess(trial) = PM(Ncond*(cond-1)+Ncond).seLapse(trial);
    PM(Ncond*(cond-1)+Ncond).guessUniformPrior(trial) = PM(Ncond*(cond-1)+Ncond).lapseUniformPrior(trial);
    PM(Ncond*(cond-1)+Ncond).seGuessUniformPrior(trial) = PM(Ncond*(cond-1)+Ncond).seLapseUniformPrior(trial);
end
if trial == PM(Ncond*(cond-1)+Ncond).numTrials
    PM(Ncond*(cond-1)+Ncond).stop = 1;
end
