function UD = updateStaircase(UD,cond,Ncond,response)
%
% Ki@ɂ̎hx𓾂(nXV)
%
%  UD       : initStaircaseŏ\̖
%  cond     : ԍ
%  Ncond    : nԍ
%  response : 񓚂̐(=1 =0)
%
% UD = updateStaircase(UD,cond,Ncond,response)
%
% Palamedes toolbox(Prins & Kingdom, 2009)gp
%
%--------------------------------------------------------------------------
% 
% gp: Ki@(1up2down)ɂhl肷
% 
% condm  = 5;                       % 
% Ncondm = 3;                       % e̊Kin
% stim   = 0.1;                     % l
%
% UD     = initStaircase(condm,Ncondm,'up',1,'down',2);
%
% ** ȉ͎h񎦂Ɣ̃[vłȂ **
% 
% cond   = 2;                       % ԍ(sƂɐݒ)
% Ncond  = 2;                       % nԍ(sƂɐݒ)
% 
% test   = staircase(UD,cond,Ncond);
% stim   = stim*10^test;            % Os̎hl(l)ɑ΂ΐ(10)Ki@ɂω
% 
% response = 1;                     % 擾(0/1)
%
% UD     = updateStaircase(UD,cond,Ncond,response);
% 
%--------------------------------------------------------------------------
% Modified Palamedes toolbox 2016.10.28 by RN
%
%PAL_AMUD_updateUD  Updates structure which contains settings for and 
%   results of up/down adaptive method.
%
%   syntax: UD = PAL_AMUD_updateUD(UD, response)
%
%   After having created a structure 'UD' using PAL_AMUD_setupUD, use 
%   something akin to the following loop to control stimulus intensity
%   during experimental run:
%
%   while ~UD.stop
%       
%       %Present trial here at stimulus magnitude in 'UD.xCurrent'
%       %and collect response (1: correct/greater than, 0: incorrect/
%       %smaller than)
%
%       UD = PAL_AMUD_updateUD(UD, response); %update UD structure based 
%                                             %on response                                    
%    
%   end
%
% Introduced: Palamedes version 1.0.0 (NP)
% Modified: Palamedes version 1.4.0, 1.4.5 (see History.m)

trial = length(UD(Ncond*(cond-1)+Ncond).x);
UD(Ncond*(cond-1)+Ncond).response(trial) = response;

if trial == 1
    UD(Ncond*(cond-1)+Ncond).xStaircase(trial) = UD(Ncond*(cond-1)+Ncond).x(trial);
    if response == 1
        UD(Ncond*(cond-1)+Ncond).direction = -1;        
    else
        UD(Ncond*(cond-1)+Ncond).direction = 1;
    end
end
    
if response == 1
    UD(Ncond*(cond-1)+Ncond).d = UD(Ncond*(cond-1)+Ncond).d + 1;
    if UD(Ncond*(cond-1)+Ncond).d == UD(Ncond*(cond-1)+Ncond).down || max(UD(Ncond*(cond-1)+Ncond).reversal) < 1
        UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xStaircase(trial)-UD(Ncond*(cond-1)+Ncond).stepSizeDown;
        if UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) < UD(Ncond*(cond-1)+Ncond).xMin && strcmp(UD(Ncond*(cond-1)+Ncond).truncate,'yes')
            UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xMin;
        end
        UD(Ncond*(cond-1)+Ncond).u = 0;
        UD(Ncond*(cond-1)+Ncond).d = 0;
        UD(Ncond*(cond-1)+Ncond).reversal(trial) = 0;
        if UD(Ncond*(cond-1)+Ncond).direction == 1
            UD(Ncond*(cond-1)+Ncond).reversal(trial) = sum(UD(Ncond*(cond-1)+Ncond).reversal~=0) + 1;
        else
            UD(Ncond*(cond-1)+Ncond).reversal(trial) = 0;
        end
        UD(Ncond*(cond-1)+Ncond).direction = -1;
    else
        UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xStaircase(trial);
    end    
else
    UD(Ncond*(cond-1)+Ncond).u = UD(Ncond*(cond-1)+Ncond).u + 1;
    if UD(Ncond*(cond-1)+Ncond).u == UD(Ncond*(cond-1)+Ncond).up || max(UD(Ncond*(cond-1)+Ncond).reversal) < 1
        UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xStaircase(trial)+UD(Ncond*(cond-1)+Ncond).stepSizeUp;
        if UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) > UD(Ncond*(cond-1)+Ncond).xMax && strcmp(UD(Ncond*(cond-1)+Ncond).truncate,'yes')
            UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xMax;
        end
        UD(Ncond*(cond-1)+Ncond).u = 0;
        UD(Ncond*(cond-1)+Ncond).d = 0;
        UD(Ncond*(cond-1)+Ncond).reversal(trial) = 0;
        if UD(Ncond*(cond-1)+Ncond).direction == -1
            UD(Ncond*(cond-1)+Ncond).reversal(trial) = sum(UD(Ncond*(cond-1)+Ncond).reversal~=0) + 1;
        else
            UD(Ncond*(cond-1)+Ncond).reversal(trial) = 0;
        end
        UD(Ncond*(cond-1)+Ncond).direction = 1;
    else
        UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1) = UD(Ncond*(cond-1)+Ncond).xStaircase(trial);
    end    
end    

if strncmpi(UD(Ncond*(cond-1)+Ncond).stopCriterion,'reversals',4) && sum(UD(Ncond*(cond-1)+Ncond).reversal~=0) == UD(Ncond*(cond-1)+Ncond).stopRule
    UD(Ncond*(cond-1)+Ncond).stop = 1;
end
if strncmpi(UD(Ncond*(cond-1)+Ncond).stopCriterion,'trials',4) && trial == UD(Ncond*(cond-1)+Ncond).stopRule
    UD(Ncond*(cond-1)+Ncond).stop = 1;
end
if ~UD(Ncond*(cond-1)+Ncond).stop
    UD(Ncond*(cond-1)+Ncond).x(trial+1) = UD(Ncond*(cond-1)+Ncond).xStaircase(trial+1);
    if UD(Ncond*(cond-1)+Ncond).x(trial+1) > UD(Ncond*(cond-1)+Ncond).xMax
        UD(Ncond*(cond-1)+Ncond).x(trial+1) = UD(Ncond*(cond-1)+Ncond).xMax;
    elseif UD(Ncond*(cond-1)+Ncond).x(trial+1) < UD(Ncond*(cond-1)+Ncond).xMin
        UD(Ncond*(cond-1)+Ncond).x(trial+1) = UD(Ncond*(cond-1)+Ncond).xMin;
    end
    UD(Ncond*(cond-1)+Ncond).xCurrent = UD(Ncond*(cond-1)+Ncond).x(trial+1);
end

end